/**
 * @file main.cpp
 * @author Siwat Sirichai (siwat@siwatinc.com)
 * @brief CU Demonstration Secondary School IoT 2024 Project Main File
 * @version 1.0
 * @date 2024-03-19
 * 
 * @copyright Copyright (c) SIWAT SYSTEM 2024
 * 
 */
#pragma once
#include <ESPMegaProOS.hpp>
#include <ClimateCard.hpp>
#include <ETH.h>
#include <RemoteVariable.hpp>
#include <ESPMegaDisplayOTA.hpp>
#include <esp_gap_ble_api.h>
#include <esp_bt_main.h>
#include <esp_bt.h>
#include <esp_ibeacon_api.hpp>
#include "lcd_elements.hpp"
#include "ir_codes.hpp"
#include "display.hpp"
#include "config.hpp"

/***********************************************
 *             Function Prototypes             *
 ***********************************************/
void setup();
void loop();
void send_stop_bytes(HardwareSerial &uart);
void handle_input_change(uint8_t pin, bool state);
void handle_mqtt_message(char *topic, char *payload);
static void esp_gap_cb(esp_gap_ble_cb_event_t event, esp_ble_gap_cb_param_t *param);

#ifdef TAMPER_DETECTION
void pageChangeCallback(uint8_t page);
void touchCallback(uint8_t page, uint8_t component, uint8_t touchType);
#endif